using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace CsNetAp
{
    public partial class Form1 : Form
    {
        NonDiffNet.NonDiffClass objDiff; // eLXgIuWFNg

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // eLXgIuWFNg
            InitNonDiff();

            // eLXgt@CǍ
            String strDt0;
            String strDt1;
            String AppPath = System.AppDomain.CurrentDomain.BaseDirectory;
            strDt0 = TextRead(AppPath + "TestSJIS.txt");
            strDt1 = TextRead(AppPath + "TestUTF8.txt");

            // eLXg
            String[,] dfList;
            Boolean blnNoSp = false; // 󔒕rȂTrue
            dfList = objDiff.NonDiff(strDt0, strDt1, blnNoSp, 2, 1, 1, "file0", "file1");

            // eLXg\
            DspDiffList(dfList);
        }

        // eLXgIuWFNg
        private void InitNonDiff(){
            objDiff = new NonDiffNet.NonDiffClass();
        }

        // eLXg\
        private void DspDiffList(String[,] dfList)
        {
            // Xg
            ListInit();

            long i;
            for (i = 1; i <= dfList.GetLength(1) - 1; i++)
            {
                if (i == dfList.GetLength(1) - 1 && dfList[2, i] == "" && dfList[4, i] == "") continue;
                // \f[^ϊ(TAB̓Xy[Xɕϊ)
                String[] strDt = new String[2];
                if (dfList[2, i] == null) dfList[2, i] = "";
                if (dfList[4, i] == null) dfList[4, i] = "";
                strDt[0] = dfList[2, i].Replace("\t", " ");
                strDt[1] = dfList[4, i].Replace("\t", " ");

                // Xgݒ(\f[^ݒ)
                String[] dsp = new String[7];
                dsp[1] = "" + i;
                dsp[2] = dfList[0, i];
                dsp[3] = dfList[1, i];
                dsp[4] = strDt[0];
                dsp[5] = strDt[1];
                dsp[6] = dfList[3, i];
                ListViewItem item = new ListViewItem(dsp);

                // Xgݒ(wiFύX)
                if (dsp[2] == "ADD")
                {
                    item.BackColor = System.Drawing.Color.Pink;
                }
                else if (dsp[2] == "DEL")
                {
                    item.BackColor = System.Drawing.Color.LightGray;
                }
                else if (dsp[2] == "UPD")
                {
                    item.BackColor = System.Drawing.Color.Cyan;
                }
                else
                {
                    item.BackColor = System.Drawing.Color.White;
                }

                // Xgݒ(sǉ)
                ListView1.Items.Add(item);
            }
        }

        // eLXgt@CǍ
        private String  TextRead(String fpath )
        {
            String TextRd = "";
            System.IO.Stream sr = null;
            System.IO.BinaryReader br = null;
            try
            {
                // eLXgoCgzœǍ
                sr = System.IO.File.Open(fpath, System.IO.FileMode.Open, System.IO.FileAccess.Read);
                br = new System.IO.BinaryReader(sr);
                byte[] bytCode = new byte[sr.Length];
                br.Read(bytCode, 0, bytCode.Length);

                // R[h(blnBin=oCiL)
                String codeName;
                codeName = objDiff.GetCodeName(ref bytCode, /*blnBin:=*/true);

                // R[hϊ
                switch( codeName)
                {
                    case "SJIS":
                        TextRd = objDiff.SJIS_To_VbUnicode(ref bytCode);
                        break;
                    case "JIS":
                        TextRd = objDiff.JIS_To_VbUnicode(ref bytCode);
                        break;
                    case "EUC":
                        TextRd = objDiff.EUC_To_VbUnicode(ref bytCode);
                        break;
                    case "UNICODE":
                        TextRd = objDiff.UNICODE_To_VbUnicode(ref bytCode);
                        break;
                    case "UTF7":
                        TextRd = objDiff.UTF7_To_VbUnicode(ref bytCode);
                        break;
                    case "UTF8":
                        TextRd = objDiff.UTF8_To_VbUnicode(ref bytCode);
                        break;
                    case "BIN":
                        TextRd = objDiff.SJIS_To_VbUnicode(ref bytCode);
                        break;
                    default:
                        TextRd = objDiff.SJIS_To_VbUnicode(ref bytCode);
                        break;
                }
                return TextRd;
            }
            catch(Exception  ex)
            {
                throw ex;
            }
            finally
            {
                if (br != null) br.Close();
                if (sr != null) sr.Close();
            }
        }

        // Xg
        private void ListInit()
        {
            ListView1.Items.Clear();
            ListView1.FullRowSelect = true;
            ListView1.GridLines = true;
            ListView1.View = View.Details;
            ColumnHeader columnDmy  = new ColumnHeader();
            ColumnHeader columnNo0  = new ColumnHeader();
            ColumnHeader columnTyp   = new ColumnHeader();
            ColumnHeader columnNo1   = new ColumnHeader();
            ColumnHeader columnFl1   = new ColumnHeader();
            ColumnHeader columnFl2   = new ColumnHeader();
            ColumnHeader columnNo2   = new ColumnHeader();
            columnDmy.Width = 0;
            columnNo0.Text = "No.";
            columnNo0.Width = 45;
            columnTyp.Text = "";
            columnTyp.Width = 45;
            columnNo1.Text = "sNo.";
            columnNo1.Width = 45;
            columnFl1.Text = "t@CP";
            columnFl1.Width = 265;
            columnFl2.Text = "t@CQ";
            columnFl2.Width = 265;
            columnNo2.Text = "sNo.";
            columnNo2.Width = 45;
            ColumnHeader[] colHeaderRegValue   = 
                {columnDmy, columnNo0, columnTyp, columnNo1, columnFl1, columnFl2, columnNo2};
            ListView1.Columns.AddRange(colHeaderRegValue);
        }
    }
}